# __gnu_cxx::bitmap_allocator< _Tp > Class Template Reference

Inheritance diagram for __gnu_cxx::bitmap_allocator< _Tp >:

List of all members.

## Detailed Description

### template<typename _Tp>
class __gnu_cxx::bitmap_allocator< _Tp >

Definition at line 710 of file bitmap_allocator.h.

## Public Types

- typedef free_list::__mutex_type __mutex_type
- typedef const _Tp * const_pointer
- typedef const _Tp & const_reference
- typedef ptrdiff_t difference_type
- typedef _Tp * pointer
- typedef _Tp & reference
- typedef size_t size_type
- typedef _Tp value_type

## Public Member Functions

- pointer _M_allocate_single_object () throw (std::bad_alloc)
- void _M_deallocate_single_object (pointer __p) throw ()
- const_pointer address (const_reference __r) const
- pointer address (reference __r) const
- pointer allocate (size_type __n, typename bitmap_allocator< void >::const_pointer)
- pointer allocate (size_type __n)
- template<typename _Tp1> bitmap_allocator (const bitmap_allocator< _Tp1 > &) throw ()
- bitmap_allocator (const bitmap_allocator &)
- bitmap_allocator () throw ()
- void construct (pointer __p, const_reference __data)
- void deallocate (pointer __p, size_type __n) throw ()
- void destroy (pointer __p)
- size_type max_size () const throw ()
- ~bitmap_allocator () throw ()

## Classes

- struct rebind

## Member Function Documentation

template<typename _Tp>

pointer __gnu_cxx::bitmap_allocator< _Tp >::_M_allocate_single_object | ( |  | ) | throw (std::bad_alloc)`[inline]`

Allocates memory for a single object of size sizeof(_Tp).

Exceptions:

  | std::bad_alloc. | If memory can not be allocated.

Complexity: Worst case complexity is O(N), but that is hardly ever hit. If and when this particular case is encountered, the next few cases are guaranteed to have a worst case complexity of O(1)! That's why this function performs very well on average. You can consider this function to have a complexity referred to commonly as: Amortized Constant time.

Definition at line 846 of file bitmap_allocator.h.

References __gnu_cxx::__detail::__bit_allocate(), __gnu_cxx::__detail::__find_if(), __gnu_cxx::__detail::__num_bitmaps(), and __gnu_cxx::_Bit_scan_forward().

template<typename _Tp>

void __gnu_cxx::bitmap_allocator< _Tp >::_M_deallocate_single_object | ( | pointer | __p | ) | throw ()`[inline]`

Deallocates memory that belongs to a single object of size sizeof(_Tp).

Complexity: O(lg(N)), but the worst case is not hit often! This is because containers usually deallocate memory close to each other and this case is handled in O(1) time by the deallocate function.

Definition at line 944 of file bitmap_allocator.h.

References __gnu_cxx::__detail::__bit_free(), __gnu_cxx::__detail::__find_if(), __gnu_cxx::__detail::__num_bitmaps(), std::__rotate(), and _GLIBCXX_DEBUG_ASSERT.

The documentation for this class was generated from the following file:

- bitmap_allocator.h